/*
 * --------------------
 * THIS FILE IS LICENSED UNDER THE FOLLOWING TERMS
 *
 * this code may not be used for any purpose. be gay, do crime
 *
 * THE FOLLOWING MESSAGE IS NOT A LICENSE
 *
 * <barrow@tilde.team> wrote this file.
 * by reading this text, you are reading "TRANS RIGHTS".
 * this file and the content within it is the gay agenda.
 * if we meet some day, and you think this stuff is worth it,
 * you can buy me a beer, tea, or something stronger.
 * -Ezra Barrow
 * --------------------
 */

use daemonize::Daemonize;
use tokio_tun::Tun;

use std::fs::File;
use std::sync::Arc;

use sleepytunny::config::Configuration;

#[tokio::main]
async fn main() -> anyhow::Result<()> {
    let c = Arc::new(Configuration::load_config("server.toml")?);
    let tun = Tun::builder()
        .name("sleepy")
        .tap(false)
        .packet_info(true)
        .address(c.interface.address)
        .netmask(c.interface.netmask)
        .up()
        .try_build()?;
    let keypair = &c.tls()?.load()?;
    let user = &c.server()?.user()?;
    let group = &c.server()?.group()?;
    let stdout = File::create(c.server()?.stdout()?)?;
    let stderr = File::create(c.server()?.stderr()?)?;

    let daemonize = Daemonize::new()
        .user(user.as_str())
        .group(group.as_str())
        .stdout(stdout)
        .stderr(stderr);
    if c.server()?.daemonize()? {
        match daemonize.start() {
            Ok(_) => sleepytunny::server_main(c.clone(), tun, keypair.clone()).await,
            Err(e) => {
                eprintln!("Error, {}", e);
                panic!()
            }
        }
    } else {
        sleepytunny::server_main(c.clone(), tun, keypair.clone()).await
    }
}
